zoukankan      html  css  js  c++  java
  • hdu 1050 Moving Tables

    Moving Tables

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 40166    Accepted Submission(s): 13230


    Problem Description
    The famous ACM (Advanced Computer Maker) Company has rented a floor of a building whose shape is in the following figure. 



    The floor has 200 rooms each on the north side and south side along the corridor. Recently the Company made a plan to reform its system. The reform includes moving a lot of tables between rooms. Because the corridor is narrow and all the tables are big, only one table can pass through the corridor. Some plan is needed to make the moving efficient. The manager figured out the following plan: Moving a table from a room to another room can be done within 10 minutes. When moving a table from room i to room j, the part of the corridor between the front of room i and the front of room j is used. So, during each 10 minutes, several moving between two rooms not sharing the same part of the corridor will be done simultaneously. To make it clear the manager illustrated the possible cases and impossible cases of simultaneous moving. 



    For each room, at most one table will be either moved in or moved out. Now, the manager seeks out a method to minimize the time to move all the tables. Your job is to write a program to solve the manager’s problem.
     

     

    Input
    The input consists of T test cases. The number of test cases ) (T is given in the first line of the input. Each test case begins with a line containing an integer N , 1<=N<=200 , that represents the number of tables to move. Each of the following N lines contains two positive integers s and t, representing that a table is to move from room number s to room number t (each room number appears at most once in the N lines). From the N+3-rd line, the remaining test cases are listed in the same manner as above.
     

     

    Output
    The output should contain the minimum time in minutes to complete the moving, one per line.
     

     

    Sample Input
    3 4 10 20 30 40 50 60 70 80 2 1 3 2 200 3 10 100 20 80 30 50
     

     

    Sample Output
    10 20 30
     

     

    Source
     

     

    Recommend
    We have carefully selected several similar problems for you:  1051 1009 1052 1789 1045 
    思路:说好的贪心,真没想出来怎么贪,要不就是暴力小的先进行。
     
    感谢老兄脑洞解法,这个题我觉得不应该归为贪心,但是脑洞解法我很喜欢
    #include<cstdio>
    #include<cmath>
    #include<cstring>
    #include<iostream>
    #include<algorithm>
    using namespace std;
    int main()
    {
        int a[202];
    
        int t; cin >> t;
        while (t--){
            int n; cin >> n;
            memset(a, 0, sizeof(a));
            int max = 0;
            while (n--){
                int s, t, cs, ct; cin >> s >> t;
    
                if (s % 2 == 0)cs = s / 2;
                else cs = (s + 1) / 2;
    
                if (t % 2 == 0)ct = t / 2;
                else ct = (t + 1) / 2;
    
                s = min(cs, ct);
                t = cs > ct ? cs : ct;
    
                for (int i = s; i <= t; i++)
                {
                    a[i]++;
                    if (max < a[i])max = a[i];
                }
            }
            cout << max * 10 << endl;
        }
        return 0;
    }
  • 相关阅读:
    关于RAM的空间使用超过限度的时候报错
    (转载)关于stm32编译后的代码空间和ram占用
    PCB文件过大的解决方法
    AD15的破解
    AD2017破解步骤
    STM32下载报错invalid rom table
    (转载)关于FLASH寿命的读写方法
    步进电机的单双极驱动
    74系列芯片中的LVC,LS,HC等的含义
    DDR3 multi-controller on ML605
  • 原文地址:https://www.cnblogs.com/zengguoqiang/p/8821313.html
Copyright © 2011-2022 走看看